#include "robber.h"
#include <iostream>
#include <iterator>
#include <queue>
#include <cmath>

using namespace std;
using namespace __gnu_cxx;

string Robber::turn(){

	//Ignore bribing for now
	cout << "nobribe:" << endl;
	string input;
	//cerr << "New turn" << endl;
	getline(cin,input);
	_time = clock();

	//cerr << "Starting to calculate shortest path" << endl;
	list<string> l = shortestPath(_location, robber,*this, *this);
	_oldLocation = _location;
	if (l.size() > 0){
		//cerr << "Found a route" << endl;
		list<string>::iterator i = l.begin();
		_location = *++i;
	}
	//cerr << "Moving to: " << _location << endl;
	return _location;
}

int Robber::operator()(const SPInfo* node) const{
	//cerr << "Goal for " << node->name << endl;
	hash_map<string,int>::const_iterator bank = _banks.find(node->name);
	if (bank != _banks.end() && bank->second > 0)
		return 1;
	if ((clock()-_time)/CLOCKS_PER_SEC > 2.4)
		return 1;
	return 0;
}

int Robber::cost(const std::string& from, const std::string& to) const{

	//cerr << "Calculating cost between " << from << " and " << to << endl;
	hash_map<string,Intersection>::const_iterator conInter =  _intersections.find(to);
	if (conInter == _intersections.end())
		return 1000000; //Should never happen

	int cost = 1;

	int max = 10;
	list<string> closestFootCop = shortestPath(to, cop_foot, FindPlayer(_players, cop_foot, max), true);
	unsigned int closestCop = closestFootCop.size();
	bool copInCar = false;
	//cerr << "Cop on fot " << closestCop << " intersections away: ";
	//copy(closestFootCop.begin(), closestFootCop.end(), ostream_iterator<string>(cerr, " : "));
	//cerr << endl;

	if (closestCop > 0)
		max = closestCop;

	if (max > 1){
		list<string> closestCarCop = shortestPath(to, cop_car, FindPlayer(_players, cop_car, max - 1), true);
		//cerr << "Cop in car " << closestCarCop.size() << " intersections away." << endl;

		if (closestCarCop.size() > 0){
			closestCop = closestCarCop.size();
			copInCar = true;
		}
	}

	//cerr << "Cop " << closestCop << " intersections away." << endl;
	if (closestCop > 0 && closestCop < 4)
		return 100;

	//cerr << "cost before cop: " << cost << endl;
	if (closestCop > 2){
		//cerr << "Cop " << closestCop << " intersections away." << endl;
		cost += 12 - (copInCar ? closestCop : closestCop - 1);
	}
	//cerr << "cost after cop: " << cost << endl;

	if (conInter->second.type == bank){
		//cerr << "FOUND A BANK" << endl;
		if (closestCop > 0 && closestCop < 4)
			return 1000;
		else if (_banks.find(to)->second > 0){
			//cerr << "No cop close to bank" << endl;
			return 1;
		}
	}

	if (to == _oldLocation)
		cost *= 2;
	//cerr << "Street: " << to << " cost: " << cost << endl;

	return cost;
}

void Robber::move(std::string location){
	cout << "rmov\\" << endl;
	Bot::move(location);
	cout << "nobribe:" << endl;
	cout << "rmov/" << endl;
}

int main(){
	Robber robber("harv-robber");
	robber.play();

	return 0;
}

#include "../botsrc/shortestPath.cpp"
